function path_opt = A_star_algo(node_g)
%% appliquer algorithme A*
% find the optimal path with node_g graph
% Node_start = node_g(1); Node_end = node_g(end)
% Initialize: cost values (heuristic cost) of each nodes
for i=1:size(node_g,2)
    node_g(i).gCost = [0];
    node_g(i).hCost = [10e4];
    node_g(i).fCost = node_g(i).gCost + node_g(i).hCost;
    node_g(i).parent = [];
end

% Assign start and end nodes
Node_start = node_g(1);
Node_end = node_g(end);

%
OPEN_queue = [Node_start];
CLOSE_queue = [];
while ~(isempty(OPEN_queue))
    Node_current = OPEN_queue(1); % OPEN_queue is sorted by lowest f-cost function.
    % check the node is End node or not
    if isequal(Node_current.pos,Node_end.pos)
        break;
    end
    % Remove the current node from OPEN_queue and add to CLOSE_queue
    OPEN_queue(1) = [];
    CLOSE_queue = [CLOSE_queue Node_current];
    
    % tasks with adjacent nodes of the current node
    for i=1:size(Node_current.adjNode,2),
        
        % get position of nodes to check if it belongs to CLOSE_queue or not
        XY_adjNode_pos = Node_current.adjNode(i).pos;
        %
        for j=1:size(CLOSE_queue,2)
            XY_CLOSE_pos(j,:) = CLOSE_queue(j).pos;
        end
     
       
        % get position of nodes to check if it belongs to OPEN_queue or not
        if isempty(OPEN_queue)
            XY_OPEN_pos = [inf inf];
        else
            for j=1:size(OPEN_queue,2)
                XY_OPEN_pos(j,:) = OPEN_queue(j).pos;
            end
        end
        %
        index_n_c = findNode(Node_current,node_g);
        index_n_adj = findNode(Node_current.adjNode(i),node_g);
        
        %
        if ismember(XY_adjNode_pos,XY_CLOSE_pos,'rows')  % if adjacent node of the current node in the CLOSE_queue
            continue;
        end
        
        % check position of nodes to check if it belongs to OPEN_queue or not
        if ~(ismember(XY_adjNode_pos,XY_OPEN_pos,'rows')) % if adjacent node of the current node is not in the OPEN_queue!
            OPEN_queue = [OPEN_queue node_g(index_n_adj)];
            
            % find index of Node_current and Node_current.adjNode(i) in the
            % node_g list
  %          index_n_c = findNode(Node_current,node_g);
  %          index_n_adj = findNode(Node_current.adjNode(i),node_g);
            % assign parent for the node
            node_g(index_n_adj).parent = node_g(index_n_c);%
            
            % compute cost function:g, h, and f = g + h of this adjacent
            % node from the initial node
            % g-cost
            
            node_g(index_n_adj).gCost = [node_g(index_n_c).gCost+node_g(index_n_c).edgeCost(i)];% sum of the distances
            % h-cost
            node_g(index_n_adj).hCost = [sqrt((node_g(index_n_adj).pos(1)-node_g(end).pos(1)).^2+(node_g(index_n_adj).pos(2)-node_g(end).pos(2)).^2)];
            node_g(index_n_adj).fCost = node_g(index_n_adj).gCost + node_g(index_n_adj).hCost;
        end
        %
        if ismember(XY_adjNode_pos,XY_OPEN_pos,'rows') % if adjacent node of the current node is in the OPEN_queue!
           % update cost functions of this adjacent node
           %
           % find index of Node_current and Node_current.adjNode(i) in the
           % node_g list
 %          index_n_c = findNode(Node_current,node_g);
 %          index_n_adj = findNode(Node_current.adjNode(i),node_g);
           %
           d_cur_adj = node_g(index_n_c).edgeCost(i);
           g_hat_cost = node_g(index_n_c).gCost + d_cur_adj;
           if g_hat_cost >= node_g(index_n_adj).gCost,
               continue
           else % update
                node_g(index_n_adj).gCost = g_hat_cost;
                node_g(index_n_adj).fCost = node_g(index_n_adj).gCost + node_g(index_n_adj).hCost;
                node_g(index_n_adj).parent = node_g(index_n_c);%
           end
        end
    end
   % resort and keep OPEN_queue sorted by f values
   OPEN_queue=lowestResort(OPEN_queue);
end
%
% track to find the optimal path
node_p = node_g(end);
path_list = [node_p];
while ~isequal(node_p.pos,node_g(1).pos)
    node_p = node_p.parent;
    path_list = [path_list node_p];
end

path_opt = path_list;
end

%
% resort the list with the lowest cost function, f
function queue_sort = lowestResort(queue)
    for i=1:(size(queue,2)-1)
        for j=i+1:size(queue,2)
            if queue(j).fCost < queue(i).fCost
                node_temp = queue(i);
                queue(i) = queue(j);
                queue(j) = node_temp;
            end
        end
    end
    queue_sort = queue;
end
% find index of a Node in a Node_list
function index = findNode(Node,Node_list)
    xy_Node = Node.pos;
    for i=1:size(Node_list,2)
        xy_Node_list(i,:) = Node_list(i).pos;
    end
    [aa,index]=ismember(xy_Node,xy_Node_list,'rows');
end